package com.zipcodewilmington.froilansfarm;

import com.zipcodewilmington.froilansfarm.Classes.*;
import com.zipcodewilmington.froilansfarm.Collections.*;
import com.zipcodewilmington.froilansfarm.Interfaces.FarmVehicle;
import com.zipcodewilmington.froilansfarm.Interfaces.Rider;

import java.util.*;

public class Farm {
    Field field = new Field(Arrays.asList(
            new CropRow(new CornStalk()),
            new CropRow(new TomatoPlant()),
            new CropRow(new CornStalk()),
            new CropRow(new SoybeanPlant()),
            new CropRow(new SoybeanPlant())
    ));

    ChickenCoop chickenCoop1 = new ChickenCoop(Arrays.asList(new Chicken("chic1"), new Chicken("chic2"), new Chicken("chic3"), new Chicken("chic4")));
    ChickenCoop chickenCoop2 = new ChickenCoop(Arrays.asList(new Chicken("chic2"), new Chicken("chic3"), new Chicken("chic4"), new Chicken("chic5")));
    ChickenCoop chickenCoop3 = new ChickenCoop(Arrays.asList(new Chicken("chic3"), new Chicken("chic4"), new Chicken("chic5"), new Chicken("chic6")));
    ChickenCoop chickenCoop4 = new ChickenCoop(Arrays.asList(new Chicken("chic4"), new Chicken("chic5"), new Chicken("chic6"), new Chicken("chic7")));
    List<ChickenCoop> coops = new ArrayList<ChickenCoop>(Arrays.asList(chickenCoop1,chickenCoop2,chickenCoop3,chickenCoop4));

    Stable stable1 = new Stable(Arrays.asList(new Horse("horse1"), new Horse("horse2"), new Horse("horse3")));
    Stable stable2 = new Stable(Arrays.asList(new Horse("horse4"), new Horse("horse5"), new Horse("horse6")));
    Stable stable3 = new Stable(Arrays.asList(new Horse("horse7"), new Horse("horse8"), new Horse("horse9")));

    List<Stable> stables = new ArrayList<Stable>(Arrays.asList(stable1,stable2,stable3));

    Tractor tractor = new Tractor();
    ManureSpreader manureSpreader = new ManureSpreader();
    Cropduster aircraft = new Cropduster();

    FarmHouse homestead = new FarmHouse(Arrays.asList(new Froilan(), new Froilanda(), new Feelan()));

    public void morningRitual() {
        // Daily morning routine
        for (Person person : homestead) {
            for (Stable stable : stables) {
                if (person instanceof Rider) {
                    for (Horse horse : stable) {
                        Rider rider = (Rider) person;
                        rider.mount(horse);
                        rider.ride(horse);
                        rider.dismount(horse);
                    }
                }
                for (Horse horse : stable) {
                    horse.makeNoise();
                    for (int portion = 0; portion < 3; portion++) {
                        horse.eat(new EarOfCorn());
                    }
                }
            }
            switch (person.getName()) {
                case "Froilan":
                    for (int portion = 0; portion < 1; portion++) {
                        person.eat(new EarOfCorn());
                    }
                    for (int portion = 0; portion < 2; portion++) {
                        person.eat(new Tomato());
                    }
                    for (int portion = 0; portion < 5; portion++) {
                        person.eat(new Egg());
                    }
                    break;
                case "Froilanda":
                    for (int portion = 0; portion < 2; portion++) {
                        person.eat(new EarOfCorn());
                    }
                    for (int portion = 0; portion < 1; portion++) {
                        person.eat(new Tomato());
                    }
                    for (int portion = 0; portion < 2; portion++) {
                        person.eat(new Egg());
                    }
                    break;
                case "Feelan":
                    for (int portion = 0; portion < 3; portion++) {
                        person.eat(new Tomato());
                    }
                    for (int portion = 0; portion < 2; portion++) {
                        person.eat(new Egg());
                    }
                    break;
                default:
                    System.out.println("Who the heck is this tryna eat my food? In the words of 2LiveCrew, \"GTFO, GTFO, GTFO of my house, b****!\"");
            }
        }
    }

}
